package com.beagle.informix.entity.jpa;

import lombok.Data;

import javax.persistence.*;
import java.io.Serializable;
import java.sql.Blob;

/**
 * @author lzz
 * date 2023/5/30
 * @version 1.0
 * description:
 */
@Data
@Table(name = "cti_vccinfo_new")
@Entity
public class Vccinfo implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    // todo 这个id自动生成方式还需测试
    @Column(name = "vccid")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer vId;
    @Column(name = "vccname")
    private String vName;
    @Column(name = "effective")
    private Integer effective;
    @Column(name = "agentmax")
    private Integer agentMax;
    @Column(name = "ivrmax")
    private Integer ivrMax;
    @Column(name = "updatekey")
    private String updateKey;
    @Column(name = "tclob")
    @Basic(fetch = FetchType.LAZY)
    private String tClob;

    @Lob
    @Basic(fetch = FetchType.LAZY)
    @Column(name = "tblob", columnDefinition = "longblob", nullable = true)
    private byte[] tBlob;
}
